]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame_incremental - rpm.macros
- 1.577: %cmake includes -DCMAKE_BUILD_TYPE, -DCMAKE_INSTALL_PREFIX, -DLIB_SUFFIX...
[packages/rpm-build-macros.git] / rpm.macros
... / ...
CommitLineData
1# $Revision$, $Date$
2# PLD Linux rpm macros.
3# <http://www.pld-linux.org/>
4
5# can be used by builder script to check for version
6%rpm_build_macros %(R="$Revision$"; RR="${R##: }"; echo ${RR%%?})
7
8%epoch 0
9%x8664 x86_64 amd64 ia32e
10%arm armv3l armv4b armv4l armv5teb armv5tel
11
12# kernel compiler
13%kgcc %{__cc}
14%kgcc_package gcc
15
16# compiler version
17%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
18%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
19
20%__rm /bin/rm --interactive=never
21
22# Build system path macros.
23%__autoconf autoconf %{?debug:-Wall}
24%__automake automake -a -c -f --foreign
25%__autopoint autopoint --force
26
27# add parallel build flags: -jN
28#
29# if you want to disable parallel build do:
30# echo '%_smp_mflags %{nil}' >> ~/.rpmmacros
31#
32%__make /usr/bin/make %{?_smp_mflags}
33%__scons /usr/bin/scons %{?_smp_mflags}
34%__waf /usr/bin/waf %{?_smp_mflags}
35%__cmake /usr/bin/cmake
36
37%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
38 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
39
40%__gettextize { \
41 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
42 gettextize --copy --force --no-changelog; \
43 else \
44 gettextize --copy --force --no-changelog --intl; \
45 fi; \
46 if [ ! -f po/Makevars ]; then \
47 cp -f po/Makevars{.template,}; \
48 fi; \
49}
50
51%__glib_gettextize glib-gettextize --copy --force
52%__gnome_doc_common gnome-doc-common --copy
53%__gnome_doc_prepare gnome-doc-prepare --copy --force
54%__gtkdocize gtkdocize --copy
55%__intltoolize intltoolize --copy --force
56%__libtoolize libtoolize --copy --force --install
57
58# topdir is where builder script lives,
59# fallback to old style if SPECS/SOURCES dirs were found.
60%_topdir %{expand:%%global _topdir %(
61 if [ -d SPECS -a -d SOURCES ]; then
62 # old style rpmdir: in topdir
63 pwd
64 elif [ -d ../SPECS -a -d ../SOURCES ]; then
65 # old style rpmdir: in subdir
66 cd ..; pwd
67 elif [ -d $HOME/rpm/SPECS -a -d $HOME/rpm/SOURCES ]; then \
68 # if old style rpm dir exist, go with it
69 echo $HOME/rpm; \
70 elif [ -x ../builder -a ! -d ../builder ]; then
71 # relative new style rpmdir: in package dir
72 cd ..; pwd
73 elif [ -x builder -a ! -d builder ]; then
74 # relative new style rpmdir: in packages
75 pwd
76 elif [ -x packages/builder -a ! -d packages/builder ]; then
77 # relative new style rpmdir: packages dir in current dir
78 cd packages; pwd
79 else
80 # fallback to new style rpmdir
81 echo $HOME/rpm/packages
82 fi; \
83)}%_topdir
84
85# if %{_topdir}/SPECS exists, it's old style structure
86%_specdir %{expand:%%global _specdir %([ ! -d %{_topdir}/SPECS ] && echo %{_topdir}/%{name} || echo %{_topdir}/SPECS)}%_specdir
87%_sourcedir %{expand:%%global _sourcedir %([ ! -d %{_topdir}/SOURCES ] && echo %{_specdir} || echo %{_topdir}/SOURCES)}%_sourcedir
88
89# BUILD/RPMS/SRPMS are one same level by default as packages dir, if these exist
90# if they don't exist assume we are having custom topdir (which is not named as
91# "packages", i.e ~/rpm/kde/{kdelibs,BUILD/RPMS/SRPMS})
92# NOTE: readlink fails if some parent dir is not readable (/home/services/builder for example can't read /home/services), therfore the extra echo
93%_builddir %{expand:%%global _builddir %(if [ -d %{_topdir}/BUILD ]; then echo %{_topdir}/BUILD; else readlink -m %{_topdir}/../BUILD || echo %{_topdir}/../BUILD; fi)}%_builddir
94%_rpmdir %{expand:%%global _rpmdir %(if [ -d %{_topdir}/RPMS ]; then echo %{_topdir}/RPMS; else readlink -m %{_topdir}/../RPMS || echo readlink -m %{_topdir}/../RPMS; fi)}%_rpmdir
95%_srcrpmdir %{expand:%%global _srcrpmdir %(if [ -d %{_topdir}/SRPMS ]; then echo %{_topdir}/SRPMS; else readlink -m %{_topdir}/../SRPMS || echo readlink -m %{_topdir}/../SRPMS; fi)}%_srcrpmdir
96
97# The number of cvs changelog entries kept when building package.
98%_buildchangelogtruncate 20
99
100%dependencytracking %{nil}
101
102# Relations between package names that cause dependency loops
103# with legacy packages that cannot be fixed. Relations are
104# specified as
105# p>q
106# where package p has a Requires: on something that package q Provides:
107#
108# XXX Note: that there cannot be any whitespace within the string "p>q",
109# and that both p and q are package names (i.e. no version/release).
110%_dependency_whiteout %{nil}
111
112#-----------------------------------------------------------------
113#
114# (re)definition of %{rpm*flags} with %filterout_* support
115# BuildRequires: awk
116# BuildRequires: rpmbuild(macros) >= 1.315
117#
118# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
119# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
120# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
121# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
122# %rpmldflags = %optldflags - %filterout_ld
123#
124# Regular expressions are supported, but to avoid some character be treated
125# as regular expression it must be escaped twice.
126
127%filter_out \
128 for (i = 1; i in I; i++) { A=0; \
129 for (f in F) { \
130 if (I[i] ~ "^" F[f] "$") A=1; \
131 }; \
132 if (!A) printf(I[i] FS); \
133 }
134
135%rpmcflags %(awk 'BEGIN {
136 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
137 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
138 %{filter_out}
139}')
140
141%rpmcxxflags %(awk 'BEGIN {
142 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
143 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
144 %{filter_out}
145}')
146
147%rpmcppflags %(awk 'BEGIN {
148 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
149 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
150 %{filter_out}
151}')
152
153%rpmldflags %(awk 'BEGIN {
154 split("%{?optldflags}",I);
155 split("%{?filterout_ld}",F)
156 %{filter_out}
157}')
158
159# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
160# but, don't use it, better use gcc as linker
161%ld_rpmldflags %(awk 'BEGIN {
162 split("%{rpmldflags}",F);
163 for (f in F) {
164 s = F[f];
165 if (s ~ /^-Wl,/) {
166 s = substr(s,5);
167 gsub(/,/," ",s);
168 };
169 printf(s FS);
170 };
171}')
172
173#-----------------------------------------------------------------
174#
175# Generate a command which cleans environment, leaving only the
176# most important variables.
177# If any spec requires any additional environment it should
178# redefine %_preserve_env in following manner:
179#
180# # ADDITIONAL_VAR is required because [a good reason here]
181# %define _preserve_env ADDITIONAL_VAR
182
183%_preserve_env_base PATH HOME TMP TMPDIR SSH_AUTH_SOCK
184
185# "env -i" must end in first line of expaned macros because it's used as first line of shell script (#! env...)
186%_clean_env %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
187 split("%{?_preserve_env}", P);
188 for (i in P) {
189 p = P[i];
190 if (!ENVIRON[p] || d[p]) {
191 continue;
192 }
193 d[p] = 1;
194 split(ENVIRON[p], V, "");
195 val = p "=";
196 for (j = 1; j in V; j++) {
197 v = V[j];
198 if (v == q)
199 v = qq;
200 else if (v == "\\"")
201 v = q2q;
202 else if (v == "\\\\")
203 v = "\\\\\\\\";
204 else
205 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
206 val = val "" v;
207 }
208 printf(val " ");
209 }
210}')
211
212#-----------------------------------------------------------------
213%configure2_13 { \
214 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
215 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
216 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
217 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
218 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
219 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
220 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
221 %{?__cc:CC="%{__cc}" ; export CC ; } \
222 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
223 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
224 --host=%{_target_platform} \
225 --prefix=%{_prefix} \
226 --exec-prefix=%{_exec_prefix} \
227 --bindir=%{_bindir} \
228 --sbindir=%{_sbindir} \
229 --sysconfdir=%{_sysconfdir} \
230 --datadir=%{_datadir} \
231 --includedir=%{_includedir} \
232 --libdir=%{_libdir} \
233 --libexecdir=%{_libexecdir} \
234 --localstatedir=%{_localstatedir} \
235 --sharedstatedir=%{_sharedstatedir} \
236 --mandir=%{_mandir} \
237 --infodir=%{_infodir} \
238 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
239 %{dependencytracking} \
240}
241
242%cmake \
243CC="%{__cc}" \\\
244CXX="%{__cxx}" \\\
245CFLAGS="%{rpmcflags}" \\\
246CXXFLAGS="%{rpmcxxflags}" \\\
247LDFLAGS="%{rpmldflags}" \\\
248%{__cmake} \\\
249 -DCMAKE_INSTALL_PREFIX=%{_prefix} \\\
250 -DCMAKE_BUILD_TYPE=%{!?debug:Release}%{?debug:Debug} \\\
251%if "%{_lib}" == "lib64" \
252 -DLIB_SUFFIX=64 \\\
253%endif \
254%{nil}
255
256%scons { \
257%{__scons} \
258 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
259 CFLAGS="${CFLAGS:-%rpmcflags}" \
260 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
261 FFLAGS="${FFLAGS:-%rpmcflags}" \
262 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
263 %{?__cc:CC="%{__cc}"} \
264 %{?__cxx:CXX="%{__cxx}"} \
265 libsuffix=%{_lib} \
266 prefix=%{_prefix} \
267}
268
269# waf. see waf.spec
270%waf { \
271CC="%{__cc}" \
272CXX="%{__cxx}" \
273CPP="%{__cpp}" \
274CFLAGS="%{rpmcflags}" \
275CXXFLAGS="%{rpmcxxflags}" \
276%{__waf} \
277}
278
279#----------------------------------------------------------------
280#%configure_cache 0
281%configure_cache_file %{buildroot}.configure.cache
282
283%configure {./configure \
284 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
285 CFLAGS="${CFLAGS:-%rpmcflags}" \
286 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
287 FFLAGS="${FFLAGS:-%rpmcflags}" \
288 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
289 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
290 %{?__cc:CC="%{__cc}"} \
291 %{?__cxx:CXX="%{__cxx}"} \
292 --host=%{_target_platform} \
293 --build=%{_target_platform} \
294 --prefix=%{_prefix} \
295 --exec-prefix=%{_exec_prefix} \
296 --bindir=%{_bindir} \
297 --sbindir=%{_sbindir} \
298 --sysconfdir=%{_sysconfdir} \
299 --datadir=%{_datadir} \
300 --includedir=%{_includedir} \
301 --libdir=%{_libdir} \
302 --libexecdir=%{_libexecdir} \
303 --localstatedir=%{_localstatedir} \
304 --sharedstatedir=%{_sharedstatedir} \
305 --mandir=%{_mandir} \
306 --infodir=%{_infodir} \
307 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
308 %{dependencytracking} \
309 %{?configure_cache:--cache-file=%{configure_cache_file}} \
310}
311
312# Simple macros to simplify adding bconded options to configure scripts.
313# Each macro requires bcond name and accepts optional option name, if option
314# isn't specified bcond name is used as option name. Options returning
315# --with and --enable also allow third argument which will be added as value
316# ( --with-option=value or --enable-option=value ) in case or positive
317# condition, but won't be added otherwise ( nothing or just --disable-option ).
318
319# Requirements:
320# BuildRequires: rpmbuild(macros) >= 1.527
321
322# Usage example:
323# %{__enable bcond} - returns --enable-bcond iff build condition is set
324# %{__disable bcond option} - returns --enable-option iff bcond is not set
325# %{__enable_disable bcond option value} - returns --enable-option=value if
326# bcond is set, returns --disable-option otherwise
327
328# expand bconds to --enable-something and --disable-something
329%__enable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
330%__disable() %{expand:%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
331%__enable_disable() %{expand:%%{?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
332
333# same as above, but condition inverted
334%__enable_unless() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
335%__disable_if() %{expand:%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
336%__enable_disable_not() %{expand:%%{!?with_%{1}:--enable-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--disable-%{?2}%{!?2:%{1}}}}
337
338# expand bconds to --with-something and --without-something
339%__with() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
340%__without() %{expand:%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
341%__with_without() %{expand:%%{?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{!?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
342
343# same as above, but condition inverted
344%__with_unless() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}}
345%__without_if() %{expand:%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
346%__with_without_not() %{expand:%%{!?with_%{1}:--with-%{?2}%{!?2:%{1}}%{?3:=%{3}}}%%{?with_%{1}:--without-%{?2}%{!?2:%{1}}}}
347
348#-----------------------------------------------------------------
349
350# overload to insert debuginfo package
351%prep \
352%if 0%{?_enable_debug_packages}\
353%{debug_package}\
354%endif\
355%%prep\
356%{nil}
357
358# Location of autoconf macros
359%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir 2>/dev/null || echo ERROR)}%_aclocaldir
360
361# Location of omf files
362%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
363
364# Location of pkgconfig files
365%_pkgconfigdir /usr/%{_lib}/pkgconfig
366# noarch pkgconfig files
367%_npkgconfigdir /usr/share/pkgconfig
368
369# Location of desktop files
370%_desktopdir /usr/share/applications
371%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
372
373# Location of pixmaps for applnk/desktop files
374%_pixmapsdir /usr/share/pixmaps
375
376# Location of themable icons for applnk/desktop files
377%_iconsdir /usr/share/icons
378
379# Location of fonts directories
380%_fontsdir /usr/share/fonts
381
382# Location of Gtk and associated libraries documentation
383%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
384
385# Location of KDE documentation
386%_kdedocdir %{_defaultdocdir}/kde/HTML
387
388# unsermake script
389%__unsermake /usr/share/unsermake/unsermake
390
391# Current date
392%date %(LC_ALL=C date +"%a %b %d %Y")
393
394# Example files, programs, scripts...
395%_examplesdir /usr/src/examples
396
397# Alternative kernel type/version
398%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
399
400# The directory holding Linux kernel sources
401%_kernelsrcdir /usr/src/linux%{_alt_kernel}
402
403# SysV-style initscripts dir
404%_initddir /etc/rc.d/init.d
405
406# If non-empty "debug" macro defined, add "dbg" suffix to release number
407%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
408
409# Bootstrap release macros.
410# Usage:
411# %bcond_with bootstrap
412# Release: %{bootstrap_release 1}
413#
414# Package will have release 1 if built normally,
415# and release 0.zzz.bootstrap if built with bootstrap
416%bootstrap_release() %{!?with_bootstrap:%{1}%{?2:.%{2}}}%{?with_bootstrap:%{!?2:%(expr %{1} - 1)}%{?2:%{1}.%(expr %{2} - 1)}.zzz.bootstrap}
417
418# -n drm to generate kernel%{_alt_kernel}-drm dependency
419%releq_kernel(n:) %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
420%releq_kernel_up(n:) %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
421%releq_kernel_smp(n:) %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}%{?-n:-%{-n*}}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
422
423# -s post to generate Requires(post) dependency
424%requires_releq_kernel(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel
425%requires_releq_kernel_up(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_up
426%requires_releq_kernel_smp(s:n:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
427
428# Requires name = version-release
429%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
430# Requires: name = version
431%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
432# Requires: name = version (version based on querying package %2)
433%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
434
435# Requires: name >= version
436%requires_ge() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_ge_to %1 %1}}}
437# Requires: name >= version (version based on querying package %2)
438%requires_ge_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 >= %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
439
440%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
441
442# kernel version-release handling
443%__kernel_ver %{expand:%%global __kernel_ver %( \\
444 Z=$([ -f '%{_kernelsrcdir}/include/generated/utsrelease.h' ] && awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/{linux/version,generated/utsrelease}.h 2>/dev/null || awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
445 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
446 echo ${Z:-ERROR}; \\
447)}%__kernel_ver
448
449%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
450%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
451%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
452%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
453
454# `uname -r` to be used in @release field
455%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
456
457# sgml macros
458%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
459%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
460%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
461%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
462%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
463%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
464%docbook_sgmlcat_fix() { for l in \
465'' \
466' -- default decl --' \
467'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
468' -- hacks for opensp --' \
469'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
470'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
471'' \
472; do echo $l; done >> %1 \
473}
474
475# vim - "
476
477# minimum file size needed for compressed documents.
478# just smaller files than this get larger when compressed.
479# some stats:
480# - 0 byte file compressed was 25 bytes .gz
481# - 39 byte file was compressed as 57
482# - with test/test.spec@man 158 byte file was compressed also 158
483%_min_compress_bytes 159
484
485#-----------------------------------------------------------------
486# find and gzip all files in %{_mandir} and %{infodir}
487#
488# Requires: xargs, find
489#
490#%no_install_post_compress_docs 1
491%__spec_install_post_compress_docs { \
492%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
493 for i in /usr/share/man /usr/X11R6/man; do \
494 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
495 echo "Compress man pages: $i"; \
496 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
497 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
498 find $RPM_BUILD_ROOT$i -type l | while read a; do \
499 m=$(readlink $a); \
500 rm -f $a; \
501 echo .so ${m##*/} > $a; \
502 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
503 done; \
504 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
505 fi; \
506 done; \
507 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
508 echo "Compress info pages: %{_infodir}"; \
509 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
510 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
511 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
512 fi; \
513}; __spec_install_post_compress_docs } }
514
515#-----------------------------------------------------------------
516# Strip executable binaries and shared object files
517#
518# Requires: find, awk, strip, cut, xargs
519#
520# Special macros which affect this process:
521#%no_install_post_strip 1 # disable stripping at all
522#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
523#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
524#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
525#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
526#
527%__spec_install_post_strip {%{!?debug: \
528%{!?no_install_post_strip:__spec_install_post_strip() { \
529if [ -d "$RPM_BUILD_ROOT" ]; then \
530 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
531 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
532 if [ "$modulelist" ]; then \
533 modulecount=$(echo "$modulelist" | wc -l); \
534 printf "Stripping %d kernel modules..." $modulecount; \
535 echo "$modulelist" | xargs -l512 chmod u+w; \
536 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
537 echo "DONE"; \
538 fi; \
539 fi; \
540 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
541 if [ -n "$filelist" ]; then \
542 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
543 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
544 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
545 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
546 if [ -n "$elfexelist" ]; then \
547 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
548 chmod u+w $elfexelist; \
549 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
550 echo "DONE"; \
551 fi; \
552 if [ -n "$elfsharedlist" ]; then \
553 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
554 chmod u+w $elfsharedlist; \
555 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
556 echo "DONE"; \
557 fi; \
558 if [ -n "$archiveslist" ]; then \
559 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
560 chmod u+w $archiveslist; \
561 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
562 echo "DONE"; \
563 fi; \
564 fi; \
565 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
566 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
567 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
568 if [ -n "$filelist_all" ]; then \
569 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
570 chmod u+w $filelist_all; \
571 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
572 echo "DONE"; \
573 fi; \
574 if [ -n "$filelist_unneeded" ]; then \
575 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
576 chmod u+w $filelist_unneeded; \
577 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
578 echo "DONE"; \
579 fi; \
580 if [ -n "$filelist_debug" ]; then \
581 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
582 chmod u+w $filelist_debug; \
583 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
584 echo "DONE"; \
585 fi; \
586fi; }; __spec_install_post_strip } } }
587
588#-----------------------------------------------------------------
589# remove all RPATH from executable binaries and shared object files
590#
591# Requires: find, awk, cut, xargs, chrpath, uname
592#
593# Special macros which affect this process
594#%no_install_post_chrpath 1 # disable chrpath at all
595#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
596#
597%__spec_install_post_chrpath {%{!?debug: \
598%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
599if [ -d "$RPM_BUILD_ROOT" ]; then \
600 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
601 if [ -n "$files" ]; then \
602 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
603 fi; \
604 if [ -n "$objs" ]; then \
605 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
606 echo "$objs" | \
607 while read file; do \
608 rpath= ; \
609 chmod u+w "$file"; \
610 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
611 case $dir in \
612 '$ORIGIN' ) \
613 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
614 else rpath="$rpath:$dir" ; fi ; \
615 continue ; \
616 ;; \
617 esac ; \
618 newdir=$(readlink -m "$dir"); \
619 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
620 case $dir in \
621 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
622 echo "remove-rpath: $dir in $file"; \
623 ;; \
624 * ) \
625 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
626 else rpath="$rpath:$dir" ; fi ; \
627 ;; \
628 esac ; \
629 done ; \
630 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
631 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
632 done; \
633 fi; \
634fi; }; __spec_install_post_chrpath } } }
635
636# vim: "
637
638#-----------------------------------------------------------------
639# Find all shared object files with unresolved symbols. Warn
640# and terminate if any found (termination can be turned off by define).
641#%no_install_post_check_so 1
642%__spec_install_post_check_so { \
643 __spec_install_post_check_so() { \
644 fail=0; \
645 printf "Searching for shared objects with unresolved symbols..."; \
646 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
647 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
648 done ; \
649 echo " DONE"; \
650 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
651}; __spec_install_post_check_so }}
652
653#-----------------------------------------------------------------
654# Find and gzip all kernel modules
655#
656# Requires: find
657#
658#%no_install_post_compress_modules 1
659%__spec_install_post_compress_modules { \
660%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
661 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
662 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
663 if [ "$q" ]; then \
664 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
665 echo "$q" | xargs -r %{__gzip} -9nf; \
666 echo "DONE"; \
667 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
668 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
669 fi; \
670 fi; \
671}; __spec_install_post_compress_modules } }
672
673# Remove common Perl files we don't package
674%__spec_install_post_perl_clean {\
675%{!?no_install_post_perl_clean: \
676%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
677} }
678
679#-----------------------------------------------------------------
680# Update GConf2 schemas
681#
682# Requires: GConf2
683#
684%gconf_schema_install() \
685 umask 022; \
686 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
687 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
688%{nil}
689
690%gconf_schema_uninstall() \
691if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
692 umask 022; \
693 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
694 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
695fi; \
696%{nil}
697
698#-----------------------------------------------------------------
699# Update desktop MIME database
700# requires: desktop-file-utils
701%update_desktop_database() {{ \
702 umask 022; \
703 /usr/bin/update-desktop-database -q; \
704};} \
705%{nil}
706
707%update_desktop_database_post %update_desktop_database
708
709%update_desktop_database_postun() {{ \
710if [ "$1" = "0" ]; then \
711 %update_desktop_database \
712fi; \
713};} \
714%{nil}
715
716#-----------------------------------------------------------------
717# Update shared MIME info database
718# requires: shared-mime-info
719#
720%update_mime_database() {{ \
721 umask 022; \
722 /usr/bin/update-mime-database %{_datadir}/mime; \
723};} \
724%{nil}
725
726#-----------------------------------------------------------------
727# Update icon cache
728# requires: gtk+
729#
730%update_icon_cache() {{ \
731 umask 022; \
732 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
733};} \
734%{nil}
735
736#-----------------------------------------------------------------
737# Update scrollkeeper database
738# requires: scrollkeeper
739#
740%scrollkeeper_update_post() \
741 /usr/bin/scrollkeeper-update -q; \
742%{nil}
743
744%scrollkeeper_update_postun() \
745if [ "$1" = "0" ]; then \
746 /usr/bin/scrollkeeper-update -q; \
747fi; \
748%{nil}
749
750#-----------------------------------------------------------------
751# post %install sequence:
752# - autodeps exceptions
753# - compress all man and info pages,
754# - strip all ELF executables and ELF shared objects if not %debug.
755# - compress kernel modules if any
756
757###################################################################
758# Requires/Provides automation
759# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
760#
761%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
762%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
763%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
764%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
765%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
766
767#%_noautocompressdoc %{nil}
768#
769%_missing_doc_files_terminate_build 1%{nil}
770%_unpackaged_files_terminate_build %{nil}
771# (X)emacs support
772%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
773%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
774%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
775
776%__php_provides %{nil}
777%__php_requires %{nil}
778%__perl_provides %{nil}
779%__perl_requires %{nil}
780%__mono_provides %{nil}
781%__mono_requires %{nil}
782
783# Perl specific macro definitions.
784%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
785%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
786%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
787%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
788%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
789%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
790
791# Ruby
792%__ruby /usr/bin/ruby
793%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
794%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
795%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
796%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
797%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
798%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
799%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
800%ruby_rdocdir /usr/share/rdoc
801%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
802%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
803%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
804
805%php_pear_dir /usr/share/pear
806%php_data_dir /usr/share/php
807%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
808%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
809%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
810
811# extract php/zend api versions
812%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
813%php_minor_version %{expand:%%global php_minor_version %(awk '/#define PHP_MINOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_minor_version
814%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
815%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
816%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
817%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
818%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
819%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
820
821# helper macro
822%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
823
824# macros for public use
825# for php extensions (php-pecl)
826%requires_php_extension %{__php_api_requires modules_api php_api_version} \
827%{__php_api_requires zend_module_api} \
828%{__php_api_requires -v %php_major_version debug php_debug} \
829%{__php_api_requires -v %php_major_version thread-safety zend_zts}
830
831# for zend extensions
832%requires_zend_extension %{__php_api_requires zend_module_api} \
833%{__php_api_requires zend_extension_api} \
834%{__php_api_requires -v %php_major_version debug php_debug} \
835%{__php_api_requires -v %php_major_version thread-safety zend_zts}
836
837# for php pdo modules (php-pecl-PDO_*)
838%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
839
840# for using PHP post scripts. for PHP >= 5.0
841%php_webserver_restart \
842[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
843[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
844if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
845 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
846 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
847 %service -q php-fcgi restart \
848 fi \
849fi \
850if [ -x /etc/rc.d/init.d/php-fpm ]; then \
851 %service -q php-fpm restart \
852fi \
853%{nil}
854
855# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
856%php4_webserver_restart \
857[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
858[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
859if [ -x /etc/rc.d/init.d/php-fcgi ]; then \
860 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
861 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
862 %service -q php-fcgi restart \
863 fi \
864fi \
865%{nil}
866
867# X.org helper macros
868%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
869%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
870
871%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
872%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
873%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
874%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
875%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
876# vim: '
877
878%requires_xorg_xserver_extension \
879%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
880%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
881%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
882%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
883%{nil}
884
885%requires_xorg_xserver_xinput \
886%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
887%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
888%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
889%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
890%{nil}
891
892%requires_xorg_xserver_font \
893%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
894%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
895%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
896%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
897%{nil}
898
899%requires_xorg_xserver_videodrv \
900%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
901%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
902%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
903%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
904%{nil}
905
906# TCL specific macro definitions.
907# TODO: when th tcl is fixed use tclsh to get version: %(echo 'puts $tcl_version' | tclsh)
908%tcl_version %{expand:%%global tcl_version %(v=$(rpm -q --qf %{V} tcl | cut -d. -f1,2); echo ${v:-ERROR})}%tcl_version
909%tcl_sitearch %{_libdir}/tcl%{tcl_version}
910%tcl_sitelib %{_datadir}/tcl%{tcl_version}
911
912# Python specific macro definitions.
913# python main version
914%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
915
916# directories
917%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
918%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
919%py_scriptdir %{py_prefix}/share/python%{py_ver}
920%py_incdir /usr/include/python%{py_ver}
921%py_sitedir %{py_libdir}/site-packages
922%py_sitescriptdir %{py_scriptdir}/site-packages
923%py_dyndir %{py_libdir}/lib-dynload
924
925# pure python modules compilation
926%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
927
928%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
929
930# Software written in Python language require Python with main version
931%pyrequires_eq() Requires: %1
932
933# Python 3.x
934# python main version
935%__python3 python3
936%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
937
938# directories
939%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
940%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
941%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
942%py3_incdir /usr/include/python%{py3_ver}
943%py3_sitedir %{py3_libdir}/site-packages
944%py3_sitescriptdir %{py3_scriptdir}/site-packages
945%py3_dyndir %{py3_libdir}/lib-dynload
946
947# pure python modules compilation
948%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
949
950%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
951
952# Hardlink binary identical .pyc and .pyo files
953%__spec_install_post_py_hardlink {\
954%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
955local a b c=0 t=0; \
956if [ -d "$RPM_BUILD_ROOT" ]; then \
957 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
958 while read a; do \
959 b="${a%.pyc}.pyo"; \
960 if cmp -s "$a" "$b"; then \
961 ln -f "$a" "$b"; \
962 c=$((c + 1)); \
963 fi; \
964 t=$((t + 1)); \
965 done < __rpm_pyc; \
966 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
967 rm -f __rpm_pyc; \
968fi; \
969}; __spec_install_post_py_hardlink } }
970
971# remove python sources, so that check-files won't complain
972%py_postclean() \
973for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
974 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
975done \
976%{nil}
977
978%py3_postclean() \
979for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
980 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
981done \
982%{nil}
983
984# depmod macro
985%depmod() { \
986umask 022; \
987if [ -e /boot/System.map-%1 ]; then \
988 /sbin/depmod -a -F /boot/System.map-%1 %1; \
989else \
990 if [ -e /boot/System.map ]; then \
991 /sbin/depmod -a -F /boot/System.map %1; \
992 else \
993 /sbin/depmod -a %1; \
994 fi \
995fi; \
996}
997
998# XMMS specific macros
999%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
1000%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
1001%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
1002%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
1003%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
1004%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
1005%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
1006%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
1007%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
1008%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
1009
1010%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/;s/sparcv./sparc/;s/arm.*/arm/')}%_target_base_arch
1011
1012# user/group checking macros
1013#
1014# Usage:
1015# %userremove myuser
1016#
1017%userremove /usr/lib/rpm/user_group.sh user del
1018%groupremove /usr/lib/rpm/user_group.sh group del
1019#
1020# Usage:
1021# if %usertestrm myuser; then
1022# /usr/sbin/userdel -r myuser
1023# Note:
1024# use these macros only if you need to call userdel/groupdel with
1025# a non-standard option or take an extra action; otherwise use the
1026# %userremove/%groupremove macros
1027#
1028%usertestrm /usr/lib/rpm/user_group.sh user testrm
1029%grouptestrm /usr/lib/rpm/user_group.sh group testrm
1030# user group membership management macros
1031#
1032# Usage:
1033# %addusertogroup [-q] myuser agroup
1034#
1035# -q if user or group don't exist, don't make big noise of it (MISSINGOK behaviour)
1036#
1037# Requirements:
1038# BuildRequires: rpmbuild(macros) >= 1.515
1039%addusertogroup(q) quiet=%{-q:1} /usr/lib/rpm/user_group.sh user addtogroup %*; \
1040%{nil}
1041
1042# banner support (useful in {pre,post}{,un} and triggers)
1043#
1044# Usage:
1045# %banner name [-a] [-e] [-n] [-tn] <<EOF
1046# the banner text, the banner text
1047# the banner text, and following line
1048#EOF
1049# You can use any form of here-document, <<'EOF' <<-EOT will do.
1050# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
1051#
1052# -a - append to the banner
1053# -e - send to stderr instead of stdout
1054# -n - no show banner (overrides -t)
1055# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
1056#
1057# Tests:
1058# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
1059# rpm -E 'date | %banner -e banner' > m; sh -x m
1060#
1061%banner(aent:) ( \
1062RPM_SCRIPTVERBOSITY=5 \
1063[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
1064if [ -x /usr/bin/banner.sh ]; then \
1065 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1066else \
1067 CMD="cat%{-e: >&2}" \
1068fi \
1069eval $CMD %{?2:%2}%{?3: %3}) \
1070%{nil}
1071
1072# useradd/groupadd macros
1073# Author: Elan Ruusamäe <glen@pld-linux.org>
1074#
1075# Usage:
1076# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
1077# [-g initial_group] [-G group[,...]] login
1078#
1079# -u uid. REQUIRED
1080# -g gid/group. REQUIRED
1081# -s defaults to /bin/false
1082# -d defaults to /usr/share/empty
1083# -c No default
1084# -r is accepted but ignored (it's always set)
1085# -k skeleton dir. defaults to /usr/share/empty
1086# rpm specific flags
1087# -P package name. defaults to %{name}
1088#
1089%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
1090%{!-u:%{error:useradd: Required argument -u missing}} \
1091%{!-g:%{error:useradd: Required argument -g missing}} \
1092%{!?1:%{error:useradd: Required parameter login missing}} \
1093if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
1094 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
1095 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1096 exit 1 \
1097 fi \
1098else \
1099 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
1100 /usr/sbin/useradd \\\
1101 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
1102 -u %{-u*} \\\
1103 -r \\\
1104 -d %{-d*}%{!-d:/usr/share/empty} \\\
1105 -s %{-s*}%{!-s:/bin/false} \\\
1106 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
1107 -g %{-g*} \\\
1108 %{-M} \\\
1109 %{-G:-G %{-G*}} \\\
1110 %{expand:%{%{#}}} 1>&2 || exit $? \
1111 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
1112fi;
1113# vim: "
1114
1115# Usage:
1116# %groupadd [-P package] [-g gid] group
1117#
1118# -g gid. REQUIRED
1119#
1120# Sample:
1121# %groupadd -P %{name}-base -g %{gid} %{name}
1122
1123%groupadd(g:P:rfo) \
1124%{!-g:%{error:groupadd: Required argument -g missing}} \
1125%{!?1:%{error:groupadd: Required parameter group missing}} \
1126if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1127 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1128 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1129 exit 1 \
1130 fi \
1131else \
1132 echo "Adding group %{1} GID=%{-g*}." \
1133 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1134 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1135fi;
1136
1137# webapp macros
1138# Author: Elan Ruusamäe <glen@pld-linux.org>
1139#
1140# The config is installed/removed inside trigger, this means that you can any
1141# time install apache1/apache/lighttpd package and the configuration file is
1142# updated. if you don't need the config for various reason for specific
1143# webserver, just remove the symlink from config directory using webapp
1144# program. the trigger will not recreate the symlink on upgrades. In other
1145# words the config is linked to webserver config directory on first install of
1146# PACKAGE or WEBSERVER.
1147#
1148# Add package's webserver config to webserver webapps dir.
1149# Usage:
1150# %webapp_register [-f] WEBSERVER WEBAPP
1151#
1152%webapp_register(f) \
1153%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1154if [ -n "%{-f:1}" ] || [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1155 /usr/sbin/webapp register %1 %2\
1156fi\
1157# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1158if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1159 %{expand:%service -q %%1 reload}\
1160fi\
1161%{nil}
1162
1163# Remove package's config from webserver webapps dir.
1164# Usage:
1165# %webapp_register [-f] WEBSERVER WEBAPP
1166%webapp_unregister(f) \
1167%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1168# remove link if either of the packages are gone \
1169if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1170 /usr/sbin/webapp unregister %1 %2\
1171 %{expand:%service -q %%1 reload}\
1172fi \
1173%{nil}
1174
1175# service macro.
1176# Author: Elan Ruusamäe <glen@pld-linux.org>
1177#
1178# calls usual service restart on package %post, but skips the restart if
1179# administrator has disabled automatic service restarts in either global
1180# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1181#
1182# Usage:
1183# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1184#
1185# -q be silent when service isn't started (for scriplets restaring other package's services)
1186# -n NOOP mode, do not actually restart service
1187#
1188# Requirements:
1189# BuildRequires: rpmbuild(macros) >= 1.268
1190# Requires: rc-scripts
1191# -n option:
1192# BuildRequires: rpmbuild(macros) >= 1.450
1193%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1194
1195
1196# Java macros. based on jpackage macros.java
1197#
1198# Root directory where all Java VMs/SDK/JREs are installed.
1199%_jvmdir %{_libdir}/jvm
1200
1201# Root directory where all Java VMs/SDK/JREs expose their jars
1202%_jvmjardir %{_libdir}/jvm-exports
1203
1204# Root directory for all Java VM/SDK/JRE's private things.
1205%_jvmprivdir %{_libdir}/jvm-private
1206
1207# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1208%_jvmlibdir %{_libdir}/jvm
1209
1210# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1211%_jvmdatadir %{_datadir}/jvm
1212
1213# Root directory for all configurations parts of Java VM/SDK/JRE's
1214%_jvmsysconfdir %{_sysconfdir}/jvm
1215
1216# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1217%_jvmcommonlibdir %{_libdir}/jvm-common
1218
1219# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1220%_jvmcommondatadir %{_datadir}/jvm-common
1221
1222# Root directory for all common configurations parts of Java VM/SDK/JRE's
1223%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
1224
1225# Directory where arch-specific (JNI) version-independent jars are installed.
1226%_jnidir %{_libdir}/java
1227
1228
1229# JDK selection. Set this to name of the JDK implementation to use
1230# insead of the system default
1231#%use_jdk icedtea6
1232
1233# expands to the value with right jdk for BuildRequires header
1234# 'jdk' if %%use_jdk is not defined, jdk(%%use_jdk) otherwise
1235# The requirement will not replace current 'default' JDK
1236%required_jdk jdk%{?use_jdk:(%{use_jdk})}
1237
1238%buildrequires_jdk BuildRequires: %required_jdk
1239
1240%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm}%{?use_jdk:JAVA_HOME=%{_jvmdir}/%{use_jdk}}; echo ${JAVA_HOME:-ERROR})}%java_home
1241
1242%_javasrcdir %{_usrsrc}/java
1243
1244%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1245%jar %{java_home}/bin/jar
1246%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; %{!?use_jdk:unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd}%{?use_jdk:JAVACMD=%{java_home}/bin/java}; echo $JAVACMD)}%java
1247%javac %{java_home}/bin/javac
1248%javadoc %{java_home}/bin/javadoc
1249
1250%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
1251
1252%jpackage_script() \
1253install -d $RPM_BUILD_ROOT%{_bindir}\
1254cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1255#!/bin/sh\
1256#\
1257# %{name} script\
1258# JPackage Project <http://www.jpackage.org/>\
1259\
1260# Source functions library\
1261. %{_javadir}-utils/java-functions\
1262\
1263# Source system prefs\
1264if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1265 . %{_sysconfdir}/java/%{name}.conf\
1266fi\
1267\
1268# Source user prefs\
1269if [ -f $HOME/.%{name}rc ]; then\
1270 . $HOME/.%{name}rc\
1271fi\
1272\
1273# Configuration\
1274MAIN_CLASS=%1\
1275BASE_FLAGS=%2\
1276BASE_OPTIONS=%3\
1277BASE_JARS="%(echo %4 | tr ':' ' ')"\
1278\
1279# Set parameters\
1280set_jvm\
1281set_classpath $BASE_JARS\
1282set_flags $BASE_FLAGS\
1283set_options $BASE_OPTIONS\
1284\
1285# Let's start\
1286run "$@"\
1287EOF
1288
1289# jpackage 1.7
1290# Directory for maven depmaps
1291#
1292%_mavendepmapdir /etc/maven
1293%_mavendepmapfragdir /etc/maven/fragments
1294
1295#
1296# add_to_depmap adds an entry to the depmap. The arguments are:
1297#
1298# %1 the original groupid
1299# %2 the original artifact id
1300# %3 the version
1301# %4 the new groupid
1302# %5 the new artifactid
1303#
1304
1305%add_to_maven_depmap() \
1306install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1307cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1308<dependency>\
1309 <maven>\
1310 <groupId>%1</groupId>\
1311 <artifactId>%2</artifactId>\
1312 <version>%3</version>\
1313 </maven>\
1314 <jpp>\
1315 <groupId>%4</groupId>\
1316 <artifactId>%5</artifactId>\
1317 <version>%3</version>\
1318 </jpp>\
1319</dependency>\
1320\
1321EOF\
1322%{nil}
1323
1324#==============================================================================
1325#
1326# update_maven_depmap updates the main maven depmap
1327#
1328%update_maven_depmap() \
1329echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1330if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1331cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1332fi\
1333echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1334
1335# JAVA macros specific for PLD
1336
1337# Directory for tomcat context configuration files
1338%_tomcatconfdir %{_sharedstatedir}/tomcat/conf/Catalina/localhost
1339
1340# Tomcat cache path
1341%_tomcatcachedir %{_sharedstatedir}/tomcat/work/Catalina/localhost
1342
1343# Clear tomcat cache
1344# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1345#
1346# Usage:
1347# %%tomcat_clear_cache appname
1348#
1349# Call this script in %postun scriptlet. It will remove compiled jsps related to
1350# given app.
1351#
1352%tomcat_clear_cache() %{!?1:ERROR}%{?2:ERROR} %{__rm} -rf %{_tomcatcachedir}/%1
1353
1354# PEAR install macros
1355# Author: Elan Ruusamäe <glen@pld-linux.org>
1356#
1357# Usage:
1358# %%pear_package_setup ...
1359#
1360# -a # - also unpack SOURCE#. for PEAR bootstrapping
1361# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1362# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1363# -D - pass -D to %setup (so the build dir is not removed)
1364# -c - register channel from local channel.xml file
1365# -d - pass -d arg to pearcmd
1366#
1367# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1368# destination hierarchy. you should copy the tree to buildroot after
1369# patching/reorganizing with %%pear_package_install.
1370#
1371# additionally BUILDROOT is stripped from files and files are converted to UNIX
1372# line endings.
1373#
1374# the pear install process output is recorded to install.log, you should put it
1375# to %%doc for later debug or just for information.
1376#
1377# additionally additional-packages.txt is produced if it was detected that the
1378# package has optional dependencies. the file format is suitable of displaying
1379# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1380# automatically added for this file.
1381
1382
1383# records install.log and transforms PEAR names to PLD Linux rpm package names.
1384%__pear_install_log \
1385tee install.log \
1386# make post message of optional packages \
1387grep -E 'can optionally use|Optional feature' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1388if [ -s optional-packages.txt ]; then \
1389 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1390else \
1391 rm -f optional-packages.txt \
1392fi \
1393%{nil}
1394
1395# Command invoking PEAR CLI
1396# Same as /usr/bin/pear, except we force GMT timezone
1397%__pear %__php -doutput_buffering=1 -dopen_basedir="" -dmemory_limit=-1 -ddate.timezone=GMT %{php_pear_dir}/pearcmd.php
1398
1399%pear_install(a:d:n:zD) \
1400%__pear \\\
1401 -c %{builddir}/pearrc \\\
1402 -d doc_dir=/docs \\\
1403 -d temp_dir=/tmp \\\
1404 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1405 -d bin_dir=%{_bindir} \\\
1406 -d data_dir=%{php_pear_dir}/data \\\
1407 -d test_dir=%{php_pear_dir}/tests \\\
1408 %{-d:%(echo "%{-d*}" | awk 'BEGIN{RS=","}{printf("-d %%s \\\\\\n\\t", $1)}')} \\\
1409 install \\\
1410 --packagingroot=%{builddir} \\\
1411 --offline \\\
1412 --nodeps \\\
1413 %{-f:--force} \\\
1414 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1415 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1416%{nil}
1417
1418# The main macro.
1419# using this macro will append optional-packages.txt to the nocompressdoc list
1420# as it's displayed to user after package install. and adding additional gzip
1421# dep is just waste ;)
1422%pear_package_setup(a:d:n:zDc:) \
1423%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1424%define builddir %{_builddir}/%{srcdir} \
1425%setup -q -c -T %{-D:-D} -n %{srcdir} \
1426%{-z:%{__tar} zxf %{S:0}; %{-a:%{__tar} zxf %{S:%{-a*}}}} \
1427%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1428%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1429%pear_install \
1430%{-z:cd ..} \
1431%{__tar} --wildcards -zvxf %{S:0} package*.xml \
1432cat %{-z:$_N/}.install.log | %__pear_install_log \
1433%undos -f php,html,js,xml \
1434%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1435%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1436%{nil}
1437
1438# Copies exctracted PEAR package structure and PEAR registry to buildroot.
1439# Author: Elan Ruusamäe <glen@pld-linux.org>
1440%pear_package_install() \
1441cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1442find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1443# help the developer out a little: \
1444if [ -f _noautoreq ]; then \
1445 echo "AutoReqdep detected:" \
1446 echo "_noautoreq $(cat _noautoreq)" \
1447fi \
1448%{nil}
1449
1450# Print optional package info for pear packages
1451# Author: Elan Ruusamäe <glen@pld-linux.org>
1452# Usage:
1453# %post -p <lua>
1454# %%pear_package_print_optionalpackages
1455#
1456# Requirements:
1457# BuildRequires: rpmbuild(macros) >= 1.571
1458%pear_package_print_optionalpackages \
1459f = io.open("%{_docdir}/%{name}-%{version}/optional-packages.txt", "r") \
1460if f then \
1461 for l in f:lines() do print(l); end \
1462end \
1463%{nil}
1464
1465
1466# Register OpenLDAP schema.
1467# Author: Elan Ruusamäe <glen@pld-linux.org>
1468#
1469# Usage:
1470# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1471#
1472# -d specify dependant schemas, separated by comma
1473#
1474%openldap_schema_register(d:) \
1475for schema in %*; do \
1476 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1477 %{__sed} -i -e " \
1478 /^include.*local.schema/{ \
1479 iinclude\\t $schema\
1480 } \
1481 " /etc/openldap/slapd.conf \
1482 fi \
1483done \
1484# enable dependant schemas \
1485if [ "%{-d*}" ]; then \
1486 %{__sed} -i -e ' \
1487 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1488 s/^#// \
1489 }' /etc/openldap/slapd.conf \
1490fi \
1491%{nil}
1492
1493# Unregister OpenLDAP schema.
1494# Author: Elan Ruusamäe <glen@pld-linux.org>
1495#
1496# Usage:
1497# %%openldap_schema_unregister %{schemadir}/horde.schema
1498#
1499%openldap_schema_unregister() \
1500for schema in %*; do \
1501 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1502 %{__sed} -i -e " \
1503 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1504 # for symmetry it would be nice if we disable enabled schemas in post, \
1505 # but we really can not do that, it would break something else. \
1506 " /etc/openldap/slapd.conf \
1507 fi \
1508done \
1509%{nil}
1510
1511%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1512
1513
1514# Build modules for kernels 2.6
1515# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1516#
1517# Usage:
1518# %build_kernel_modules -m <modules> -C <directory>
1519#
1520# remember that proper Makefile is still required
1521# Options:
1522# -m <modules> (required) -- comma-separated list of modules to save,
1523# without .ko extension, may be placed in subdirectory
1524# -C <directory> -- change to <directory> before doing anything
1525# -p <arg>, -P <arg> -- arguments passeed to make scripts
1526# -c -- do not execute make clean
1527# <additional arguments> -- all additional arguments will be passed to
1528# make modules
1529#
1530# Additional patching supported via here document. Try:
1531# %build_kernel_modules -m module <<'EOF'
1532# your patch script here
1533# EOF
1534# Don't use it unless patching depends on config options.
1535
1536# Developer note: don't touch it unless you know how to handle '\'.
1537# - \ in script expands to nothing
1538# - \\\ in script expands to \
1539# - \\\ inside definition expands to nothing
1540# - \\\\\\\ inside definition expands to \
1541# - in last line \ has to touch arguments so arguments passing
1542# in new lines (using \) will be supported
1543
1544%build_kernel_modules(p:P:m:C:c) \
1545%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1546 \
1547%define Opts \\\\\\\
1548%if "%{_target_base_arch}" != "%{_arch}" \\\
1549 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
1550 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
1551 %else \\\
1552 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1553 %endif \\\
1554%else \\\
1555 CC="%{kgcc}" \\\
1556%endif \
1557%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1558 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1559 \
1560%{?-C:cd %{-C*}} \
1561compile() { \
1562 local L="<" PATCH_SH; \
1563 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1564 set -e -x \
1565 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1566 \
1567for cfg in ${cfgs:-dist}; do \
1568 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1569 \
1570 rm -rf o \
1571 install -d o/include/linux o/include/generated o/arch/powerpc/lib \
1572 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1573 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1574 if [ -f %{_kernelsrcdir}/include/generated/autoconf-$cfg.h ]; then \
1575 ln -sf %{_kernelsrcdir}/include/generated/autoconf-$cfg.h o/include/generated/autoconf.h \
1576 ln -s ../generated/autoconf.h o/include/linux/autoconf.h \
1577 else \
1578 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1579 fi \
1580 \
1581 set +x \
1582 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1583 set -x \
1584 \
1585 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
1586 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1587 %{-p*} %{-P*} \\\
1588 %{MakeOpts} \
1589 %else \
1590 install -d o/include/config \
1591 touch o/include/config/MARKER \
1592 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
1593 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1594 %endif \
1595 \
1596 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
1597 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
1598 ${1+"$@"} \\\
1599 M=$PWD %{MakeOpts}} \
1600 \
1601 %{__make} -C %{_kernelsrcdir} modules \\\
1602 ${1+"$@"} \\\
1603 M=$PWD %{MakeOpts} \
1604 \
1605 for MODULE in {%{-m*},}; do \
1606 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1607 done \
1608done \
1609%{?-C:cd -} \
1610} \
1611compile %{*}\
1612%{nil}
1613
1614
1615# Install kernel modules built by %build_kernel_modules
1616# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1617#
1618# Usage:
1619# %install_kernel_modules -m <modules> -d <directory>
1620#
1621# Options:
1622# -m <modules> (required) -- comma-separated list of modules to install,
1623# without .ko extension, may be placed in subdirectory
1624# -d <directory> (required) -- in what subdirectory modules should be
1625# installed (eg. misc, kernel/drivers/net)
1626# -s <suffix> -- suffix to use when installing modules, useful when module
1627# with same name exists in kernel already
1628# -n <file> -- name of modprobe config file to use (without .conf extension)
1629# for defining aliases, only useful with -s
1630
1631%install_kernel_modules(m:d:s:n:) \
1632%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1633%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1634%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1635 \
1636%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1637%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1638 \
1639__install_kernel_modules() { \
1640local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1641 \
1642for MODULE in {%{-m*},}; do \
1643 [ -n "${MODULE}" ] || continue \
1644 for cfg in ${cfgs:-dist}; do \
1645 [ "$cfg" = smp ] && suf=smp || suf= \
1646 MNAME=${MODULE##*/} \
1647 install -D ${MODULE}-$cfg.ko \\\
1648 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
1649 %{?-s:install -d %{ModprobeD}$suf \
1650 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1651 >> %{ModprobeD}$suf/%{-n*}.conf} \
1652 done \
1653done \
1654} \
1655__install_kernel_modules \
1656%{nil}
1657
1658# patchset macros
1659# Author: Elan Ruusamäe <glen@pld-linux.org>
1660#
1661# Usage:
1662# %patchset_source -f <seq(1) format> <start> [<end>]
1663# %patchset_patch <start> [<end>]
1664#
1665# If <end> is omited, it is assumed to be <start>.
1666#
1667# For example in preamble:
1668# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1669# and in %prep:
1670# %patchset_patch 33 44
1671
1672# generate SourceX urls from range START STOP
1673# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1674# The sources start from 10000
1675%patchset_source(f:b:) %(
1676 base=%{-b*}%{!-b*:10000};
1677 start=$(expr $base + %1);
1678 end=$(expr $base + %{?2}%{!?2:%{1}});
1679 # we need to call seq twice as it doesn't allow two formats
1680 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1681 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1682 paste %{tmpdir}/__ps{1,2};
1683 rm -f %{tmpdir}/__ps{1,2};
1684) \
1685%{nil}
1686
1687# apply sources from %patchset_source
1688# -p specify -pX for %patch line
1689# -b base offset: defaults to 10000
1690%patchset_patch(f:p:b:) %(
1691 base=%{-b*}%{!-b*:10000};
1692 start=$(expr $base + %1);
1693 end=$(expr $base + %{?2}%{!?2:%{1}});
1694 echo ": patchset_patch %1%{?2: to %2}";
1695 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1696) \
1697%{nil}
1698
1699# browser plugins v2
1700# Author: Elan Ruusamäe <glen@pld-linux.org>
1701#
1702# Usage:
1703# %browser_plugins_add_browser <name> -p <plugindir>
1704#
1705# <name> (required) -- name of the browser. usually %{name}.
1706# -p <plugindir> (required) -- in what directory browser searches for its plugins.
1707# -b -- default blacklists
1708# -a <arch> override arch
1709#
1710# Example:
1711# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1712
1713%_browserpluginsconfdir /etc/browser-plugins
1714%_browserpluginsdir %{_libdir}/browser-plugins
1715%update_browser_plugins /usr/sbin/update-browser-plugins || :
1716
1717%browser_plugins_add_browser(p:b:a:) \
1718 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1719 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1720 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1721 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1722 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1723 %{-b:cat >> $blacklist_file %{-b*}} \
1724%{nil}
1725
1726# Helper for LUA.
1727# split string separated by space into quoted list
1728#
1729# Author: Elan Ruusamäe <glen@pld-linux.org>
1730#
1731# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1732%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1733
1734# adjust /etc/shells by adding and removing shells from there
1735# Author: Elan Ruusamäe <glen@pld-linux.org>
1736#
1737# Usage:
1738# %post -p <lua>
1739# %lua_add_etc_shells /bin/sh /bin/pdksh
1740#
1741# %preun -p <lua>
1742# if arg[2] == 0 then
1743# %lua_remove_etc_shells /bin/bash /bin/rbash
1744# end
1745#
1746# Requirements:
1747# BuildRequires: rpmbuild(macros) >= 1.462
1748#
1749
1750%lua_add_etc_shells() \
1751t = {}\
1752f = io.open("/etc/shells", "r")\
1753if f then\
1754 for l in f:lines() do t[l]=l; end\
1755 f:close()\
1756end\
1757for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1758 if not t[s] then\
1759 print("Adding "..s.." to /etc/shells")\
1760 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1761 end\
1762end\
1763%{nil}
1764
1765%lua_remove_etc_shells() \
1766t = {}\
1767f = io.open("/etc/shells", "r")\
1768if f then\
1769 for l in f:lines() do t[l]=l; end\
1770 f:close()\
1771end\
1772for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1773 print("Removing "..l.." from /etc/shells")\
1774 t[l] = nil\
1775end\
1776s=""\
1777for _, l in pairs(t) do\
1778 s=s..l.."\\n"\
1779end\
1780io.open("/etc/shells", "w"):write(s)\
1781%{nil}
1782
1783# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1784#
1785# Author: Elan Ruusamäe <glen@pld-linux.org>
1786#
1787# Usage:
1788# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1789# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1790#
1791# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1792#
1793# Requirements:
1794# BuildRequires: rpmbuild(macros) >= 1.429
1795#
1796%add_etc_shells(p) %{-p:<lua>}\
1797%{expand:%%lua_add_etc_shells %*}\
1798%{nil}
1799
1800%remove_etc_shells(p) %{-p:<lua>}\
1801%{-p:if arg[2] == 0 then}\
1802%{expand:%%lua_remove_etc_shells %*}\
1803%{-p:end} \
1804%{nil}
1805
1806# Check syntax for Python files
1807#
1808# Author: Elan Ruusamäe <glen@pld-linux.org>
1809# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1810#
1811# Usage:
1812# %py_lint src
1813#
1814# Requirements:
1815# BuildRequires: python
1816# BuildRequires: rpmbuild(macros) >= 1.469
1817
1818%py_lint() \
1819__py_lint() { \
1820find "$@" -type f -name '*.py' | python -c ' \
1821import sys \
1822import compiler \
1823\
1824err = 0\
1825for f in sys.stdin: \
1826 fd = open(f.strip()) \
1827 c = fd.read() \
1828 fd.close() \
1829 try: \
1830 compiler.parse(c) \
1831 except SyntaxError, e: \
1832 print "py_lint: %s: %s" % (f.strip(), e) \
1833 err = err + 1\
1834\
1835if err: \
1836 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1837 sys.exit(1) \
1838else: \
1839 print >> sys.stderr, "py_lint: Found no syntax errors." \
1840' \
1841}; __py_lint %* \
1842%{nil}
1843
1844# Undos files
1845#
1846# Author: Paweł Zuzelski <pawelz@pld-linux.org>
1847# Author: Elan Ruusamäe <glen@pld-linux.org>
1848#
1849# Usage:
1850# %undos list_of_files
1851# %undos -f EXT[,EXT]
1852# %undos -i -f EXT[,EXT]
1853#
1854# -f EXT[,EXT] - find(1) files by extensions
1855# -i - case insensitive file search
1856#
1857# Example:
1858# Un-DOS all *.js, *.css files
1859# %undos -f js,css
1860# Un-DOS all *.js, *.JS files
1861# %undos -f js -i
1862# undos all Makefiles
1863# %{__find} -name Makefile | xargs %undos
1864#
1865# Requirements:
1866# BuildRequires: sed >= 4.0
1867# BuildRequires: rpmbuild(macros) >= 1.565
1868
1869# NB: make sure this macro stays on one line
1870# NB: make sure it includes newline escape
1871%undos(f:i) %{-f:%{__find} -regextype posix-extended -%{-i:i}regex '^.+\\.(%(echo %{-f*} | tr ',' '|'))$' -print0 | xargs -0} %{__sed} -i -e 's,\\r$,,' %* \
1872%{nil}
1873
1874# Hook to register nagios object based plugins in Nagios NRPE daemon config.
1875#
1876# Author: Elan Ruusamäe <glen@pld-linux.org>
1877#
1878# Usage:
1879# -a NAME -- add command named NAME
1880# -d NAME -- remove command named NAME
1881# -f FILE -- specify plugin configuration FILE to extract command definition from
1882#
1883# Sample:
1884# %triggerin -- nagios-nrpe
1885# %nagios_nrpe -a %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1886#
1887# %triggerun -- nagios-nrpe
1888# %nagios_nrpe -d %{plugin} -f %{_sysconfdir}/%{plugin}.cfg
1889#
1890# Requirements:
1891# Requires: grep
1892# Requires: sed >= 4.0
1893# BuildRequires: rpmbuild(macros) >= 1.552
1894%nagios_nrpe(a:d:c:f:) {\
1895 m=$(md5sum < /etc/nagios/nrpe.cfg); \
1896 %{-a:# on -a and config exists \
1897 if [ -f /etc/nagios/nrpe.cfg ]; then \
1898 if ! %{__grep} -q '^command\[%{-a*}\]' /etc/nagios/nrpe.cfg; then \
1899 %{__sed} -ne 's/^[ \t]*command_line[ \t]\+\(.\+\)/command[%{-a*}]=\1/p' %{-f*} >> /etc/nagios/nrpe.cfg; \
1900 fi; \
1901 fi;} \
1902 %{-d:# on package remove, -d and config exists \
1903 if [ "$1" = "0" -a -f /etc/nagios/nrpe.cfg ]; then \
1904 %{__sed} -i -e '/^[ \t]*command\[%{-d*}\]/d' /etc/nagios/nrpe.cfg; \
1905 fi;} \
1906 if [ "$m" != "$(md5sum < /etc/nagios/nrpe.cfg)" ]; then \
1907 %service -q nrpe restart; \
1908 fi; \
1909}%{nil}
1910
1911# Import or update Cacti template.
1912#
1913# Author: Elan Ruusamäe <glen@pld-linux.org>
1914#
1915# Usage:
1916# %cacti_import_template XMLFILE
1917# XMLFILE -- XML template to import
1918#
1919# Sample:
1920# %post
1921# %cacti_import_template %{resourcedir}/cacti_host_template_varnish.xml
1922#
1923# Requires: cacti >= 0.8.7e-8
1924# BuildRequires: rpmbuild(macros) >= 1.554
1925
1926%cacti_import_template() {\
1927/usr/share/cacti/cli/import_template.php --filename=%1 || :; \
1928}%{nil}
1929
1930# pre/post script for -upstart subpackages
1931#
1932# Author: Jacek Konieczny <jajcus@jajcus.net>
1933#
1934# Usage:
1935# %upstart_post service_name
1936# %upstart_postun service_name
1937#
1938# Sample:
1939# %post upstart
1940# %upstart_post %{name}
1941#
1942# %postun upstart
1943# %upstart_postun %{name}
1944#
1945# Requirements:
1946# BuildRequires: rpmbuild(macros) >= 1.560
1947# Requires: rc-scripts >= 0.4.3
1948
1949# migrate from init script to upstart job
1950%upstart_post() \
1951 if [ -f /var/lock/subsys/"%1" ] ; then \
1952 /sbin/service --no-upstart "%1" stop \
1953 /sbin/service "%1" start \
1954 fi
1955
1956# restart the job after upgrade or migrate to init script on removal
1957# cannot be stopped with 'service' as /etc/init/$name.conf may be missing
1958# at this point
1959%upstart_postun() \
1960 if [ -x /sbin/initctl ] && /sbin/initctl status "%1" 2>/dev/null | grep -q 'running' ; then \
1961 /sbin/initctl stop "%1" >/dev/null 2>&1 \
1962 [ -f "/etc/rc.d/init.d/%1" -o -f "/etc/init/%1.conf" ] && { echo -n "Re-" ; /sbin/service "%1" start ; } ; \
1963 fi
1964
1965# vim:ts=4 sw=4 noet ft=spec
This page took 0.070584 seconds and 4 git commands to generate.